#include <iostream>
#include <math.h>
#include <vector>
#include <time.h>
#include <stdlib.h>
#include <string>
#include <vector>

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>


/* Defines for library initializations etc */
#define S_WIDTH 640
#define S_HEIGHT 480
#define BPP 32
#define S_FLAGS SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_FULLSCREEN
SDL_Surface *pics[8];
void InitStuff(); /* screen initialization functions, misc. variables' values assigned, the particle engine's initialization functions called here */

void Draw(); /* loops through the screen and.. draws :) */


void Events();
SDL_Event event;
Uint8* pressed_key;

bool running;
/* */

SDL_Surface *screen;
SDL_Surface *noise = SDL_CreateRGBSurface(SDL_SWSURFACE,S_WIDTH,S_HEIGHT,32,0,0,0,0);;

Mix_Chunk *music;


using namespace std;

#define octaves 6
#define frequency 2
#define amplitude 255
#define persistence 2
vector<vector<int> > randoms;
vector <int> perlin;

int show_noise = 0;

int homo = 0;

int main()
{	
	InitStuff();
	
	int TEST_REMOVE = SDL_GetTicks();
	int TEST_REMOVE2 = 0;
	int FPS_REMOVE = 0;

	while (running)
	{
	  int ccolor = 0;
	  
	  if (SDL_GetTicks() > 30000)
	    ccolor = 255 + (255*((SDL_GetTicks()/50)%2)<<8);
 		SDL_FillRect(screen, NULL, ccolor);

		Draw();
		
 		SDL_Flip(screen);
		
		if (SDL_GetTicks() - TEST_REMOVE > 1000)
		{
			
			std::cout<<FPS_REMOVE<<"\n";
			std::cout<<SDL_GetTicks()/1000<<"\n";
			
			FPS_REMOVE = 0;
			TEST_REMOVE = SDL_GetTicks();
		}
		FPS_REMOVE++;
		Events();
	}
	SDL_Quit();
	return 0;
}

void Draw()
{
  
  int koo;
  
  koo = (SDL_GetTicks()/60)%2 + 4;
  
    SDL_BlitSurface(pics[koo], NULL, screen,  NULL);

	SDL_BlitSurface(pics[0], NULL, screen,  NULL);
	

	
	koo = (SDL_GetTicks()/80)%5;
	
	if (koo == 4)
	  koo = 1;
	
	SDL_BlitSurface(pics[koo], NULL, screen,  NULL);
	
 	if (SDL_GetTicks() > 10000)
	  SDL_BlitSurface(pics[6], NULL, screen,  NULL);
	
	if (SDL_GetTicks() > 20000 && SDL_GetTicks() < 30000)
	  	 SDL_BlitSurface(pics[7], NULL, screen,  NULL);
}

void InitStuff()
{
  
  
char kuvat[1][20] = {"food.png"};


  pics[0] = IMG_Load("food.png");
  SDL_SetColorKey(pics[0], SDL_SRCCOLORKEY, SDL_MapRGB(pics[0]->format,255,255,255));
  
   pics[1] = IMG_Load("tuli1.png");
   SDL_SetColorKey(pics[1], SDL_SRCCOLORKEY, SDL_MapRGB(pics[1]->format,255,255,255));
   
    pics[2] = IMG_Load("tuli2.png");
    SDL_SetColorKey(pics[2], SDL_SRCCOLORKEY, SDL_MapRGB(pics[2]->format,255,255,255));
    
     pics[3] = IMG_Load("tuli3.png");
     SDL_SetColorKey(pics[3], SDL_SRCCOLORKEY, SDL_MapRGB(pics[3]->format,255,255,255));
     
         pics[4] = IMG_Load("text1.png");
    SDL_SetColorKey(pics[4], SDL_SRCCOLORKEY, SDL_MapRGB(pics[4]->format,255,255,255));
    
     pics[5] = IMG_Load("text2.png");
     SDL_SetColorKey(pics[5], SDL_SRCCOLORKEY, SDL_MapRGB(pics[5]->format,255,255,255));
     
          pics[6] = IMG_Load("trash.png");
     SDL_SetColorKey(pics[6], SDL_SRCCOLORKEY, SDL_MapRGB(pics[6]->format,255,255,255));
     
               pics[7] = IMG_Load("campfire1.jpg");
	/* Particle engine and misc. variables */
	running = 1;
	
	/* Random generator */
	time_t seed;
    time(&seed);

    srand(seed);
    /* .. */
	
	/* Library, screen initializations */
	SDL_Init(0);
	screen = SDL_SetVideoMode(S_WIDTH, S_HEIGHT, BPP, S_FLAGS);
	
	SDL_ShowCursor(0);
	
	Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 1024);
	
 			music = Mix_LoadWAV("nuotio.ogg");
	
 	Mix_Volume(Mix_PlayChannel(-1, music, 0),MIX_MAX_VOLUME);
}

void Events()
{	
	SDL_PollEvent(&event);
	if ( event.type == SDL_QUIT )
		running = 0;

	pressed_key = SDL_GetKeyState(NULL);
	if ( pressed_key[SDLK_ESCAPE] )
		 running = 0;
	
	if ( event.type == SDL_KEYDOWN && homo == 0)
	{
	  if ( pressed_key[SDLK_LEFT] )
	    show_noise--;
	  if ( pressed_key[SDLK_RIGHT] )
	    show_noise++;
	  
	  homo = 1;
	}
	if ( event.type == SDL_KEYUP )
	  homo = 0;
}
